public void run() {
	long t1 = System.currentTimeMillis();
	while(finish == false && nTry > 0) { //retry if timeout expires
		try {
			byte[] puzzleSolution;
			String confirm = "OK";

			sendRequest(); //send access request
			p.receivePuzzle(ds); //receive the puzzle and the port of the server connected to
			if(p.getNBitPuzzle() != -1) {
				System.out.println("Trying to acced with puzzle difficulty = "+p.getNBitPuzzle());
				puzzleSolution = p.resolvePuzzle();
				//System.out.println("Resolved puzzle of "+p.getNBitPuzzle()+" bits difficulty");
				sendBytes(puzzleSolution); //send the found resolution
				confirm = receiveString(); //receive the acceptance from the server
			}else //no puzzle resolution required
				System.out.println("Acceding without puzzle");

			if(confirm.equals("OK")) {
				//System.out.println("Connection accepted");
				sendBytes("Item1".getBytes("UTF-8")); //send the resource request
				System.out.println("Resource received: "+receiveString());
				long t2 = System.currentTimeMillis();
				System.out.println("Time legitimate client: "+((double)(t2-t1))/1000);
			}else
				System.out.println("Connection refused");
			finish = true;
		}catch(SocketTimeoutException e) {
			nTry--;
			e.printStackTrace();
		}
	}
	ds.close();
}