public void startServer() {
	try {
		DatagramPacket dp = new DatagramPacket(new byte[1024], 1024);
		
		while(true) {
			ds.receive(dp); //new packet received
			InetAddress clientAddress = dp.getAddress();
			int remotePort = dp.getPort();
			byte[] receivedData = dp.getData();
			String clientID = clientAddress+":"+remotePort;
			
			if(!clients.containsKey(clientID)) {
				if(!access.containsKey(clientID))
					access.put(clientID, 1);
				else
					access.put(clientID, access.get(clientID)+1);
				int nBitPuzzle = generateNBitPuzzle(access.get(clientID));
				ClientStructure cs = new ClientStructure(receivedData, clientAddress, remotePort, nBitPuzzle);
				clients.put(clientID, cs);
				cs.getPuzzle().sendPuzzle(ds, clientAddress, remotePort);
			}else {
				ClientStructure client = clients.get(clientID);
				if(!client.isConnected()) {
					Puzzle p = client.getPuzzle();
					if(p.getNBitPuzzle() > 0) { //puzzle resolution required
						if(p.checkPuzzle(receivedData)) { //if correct resolution
							client.setConnection(true);
							sendString("OK", clientAddress, remotePort);
						}else { //puzzle not resolved
							sendString("NO", clientAddress, remotePort);
						}
					}else { //no puzzle required
						handleResourceRequest(new String(receivedData, dp.getOffset(), dp.getLength()), clientAddress, remotePort);
						clients.remove(clientID);
					}
				}else {
					handleResourceRequest(new String(receivedData, dp.getOffset(), dp.getLength()), clientAddress, remotePort);
					clients.remove(clientID); //protocol finished
				}
			}
		}
	}catch(Exception e) {
		e.printStackTrace();
	}finally {
		ds.close();
	}
}