package tesiProject;

import java.io.FileWriter;
import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.Inet4Address;
import java.net.InetAddress;
import java.net.SocketTimeoutException;
import java.nio.charset.StandardCharsets;

import javax.crypto.KeyGenerator;
import javax.crypto.spec.SecretKeySpec;

public class Client extends Thread{

	private boolean finish;
	private int serverPort, nTry;
	private InetAddress serverAddress;
	private DatagramSocket ds;
	private Puzzle p;
	private static FileWriter fw;
	
	public Client(InetAddress serverAddress, int serverPort) {
		try {
			this.finish = false;
			this.nTry = Functions.NTRY;
			this.serverPort = serverPort;
			this.serverAddress = serverAddress;
			ds = new DatagramSocket();
			ds.setSoTimeout(Functions.WAIT_TIME);
			p = new Puzzle();
		}catch(Exception e) {
			e.printStackTrace();
		}
	}

	@Override
	public void run() {
		long t1 = System.currentTimeMillis();
		while(finish == false && nTry > 0) { //retry if timeout expires
			try {
				byte[] puzzleSolution;
				String confirm = "OK";

				sendRequest(); //send access request
				p.receivePuzzle(ds); //receive the puzzle and the port of the server connected to
				if(p.getNBitPuzzle() != -1) {
					System.out.println("Trying to acced with puzzle difficulty = "+p.getNBitPuzzle());
					puzzleSolution = p.resolvePuzzle();
					//				System.out.println("Resolved puzzle of "+p.getNBitPuzzle()+" bits difficulty");
					//sendResolvedPuzzle(h, remotePort);
					sendBytes(puzzleSolution); //send the found resolution
					confirm = receiveString(); //receive the acceptance from the server
				}else //if == -1 , no puzzle resolution required
					System.out.println("Acceding without puzzle");

				//System.out.println("nBit: "+nBit);
				//System.out.println("hp: "+bytesToHex(p.getHp()));
				//System.out.println("hTrovato: "+bytesToHex(h));
				if(confirm.equals("OK")) {
					//System.out.println("Connection accepted");
					sendBytes("Item1".getBytes("UTF-8")); //send the resource request
					System.out.println("Risorsa ricevuta: "+receiveString());
					long t2 = System.currentTimeMillis();
					System.out.println("Time benefic client with difficulty "+p.getNBitPuzzle()+": "+((double)(t2-t1))/1000);
					fw.append((t2-t1)+"\n"); fw.flush();
				}else
					System.out.println("Connection refused");
				finish = true;
			}catch(SocketTimeoutException e) {
				nTry--;
				e.printStackTrace();
			}catch(Exception e) {
				finish = true;
				e.printStackTrace();
			}
		}
		ds.close();
	}
	
	private void sendRequest() {
		try {
			KeyGenerator keygen = KeyGenerator.getInstance("AES");
	        keygen.init(128);
	        //byte[] key = keygen.generateKey().getEncoded();
	        SecretKeySpec privKey = new SecretKeySpec(keygen.generateKey().getEncoded(), "AES");
			StringBuffer messageForHash = new StringBuffer();
			StringBuffer message = new StringBuffer();
			String Ac = Inet4Address.getLocalHost().getHostAddress().toString();
			byte[] hmacClient, messageSend;

			messageForHash.append(Ac).append("127.0.0.1").append("127.0.0.1");	//Ac||As||req		
			hmacClient = Functions.calcHmacSha256(privKey, messageForHash.toString().getBytes("UTF-8")); //request's hmac
			message.append(Ac).append(",").append("127.0.0.1").append(",").append("127.0.0.1").append(",")
					.append(Functions.bytesToHex(hmacClient));
			
//			System.out.println(message.toString());
			messageSend = message.toString().getBytes();
			DatagramPacket dp = new DatagramPacket(messageSend,messageSend.length,
					serverAddress, serverPort);
			ds.send(dp);
		}catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	private void sendBytes(byte[] p) {
		try {
			DatagramPacket dp = new DatagramPacket(p,p.length,
					serverAddress, serverPort);

			ds.send(dp);
		}catch(Exception e) {
			e.printStackTrace();
		}
	}

	private String receiveString() throws SocketTimeoutException{
		try {
			DatagramPacket dp = new DatagramPacket(new byte[128], 128);			
			
			ds.receive(dp);
			return (new String(dp.getData(), StandardCharsets.UTF_8)).replaceAll("\u0000", "");
		}catch(SocketTimeoutException se) {
			se.printStackTrace();
			throw se;			
		}catch(Exception e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static void setFile() throws IOException {
		Client.fw = new FileWriter("outputBenefic.txt");
	}
}