package tesiProject;

import java.net.InetAddress;
import java.sql.Timestamp;

public class ClientStructure extends Thread{
	private boolean connected;
	private Puzzle p;
	private InetAddress clientAddress;
	private int remotePort;
	private Timestamp timestamp;
	
	public ClientStructure(byte[] request, InetAddress clientAddress, int remotePort, int nBitPuzzle) {
		try {
			this.connected = false;
			this.clientAddress = clientAddress;
			this.remotePort = remotePort;
			p = new Puzzle();
			p.generatePuzzle(request, nBitPuzzle);
			timestamp = p.getTimestamp();
		}catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public InetAddress getClientAddress() {
		return clientAddress;
	}

	public int getRemotePort() {
		return remotePort;
	}
	
	public Puzzle getPuzzle() {
		return p;
	}

	public boolean isConnected() {
		return connected;
	}
	
	public void setConnection(boolean bool) {
		connected = bool;
	}
	
	public Timestamp getTimestamp() {
		return timestamp;
	}
}
