package tesiProject;
import javax.crypto.spec.SecretKeySpec;
//import java.security.PrivateKey;
import javax.crypto.Mac;

public class Functions {
	
	public static final int NTHREADS = 4;
	public static final int NTRY = 3;
	public static final int WAIT_TIME = 60000;
	public static final double CPU_THRESHOLD = 0.2;
	
	static public byte[] calcHmacSha256(SecretKeySpec secretKey, byte[] message) {
		try {
			byte[] hmacSha256 = null;
			Mac mac = Mac.getInstance("HmacSHA256");
			mac.init(secretKey);
			hmacSha256 = mac.doFinal(message);
			return hmacSha256;
		} catch (Exception e) {
			throw new RuntimeException("Failed to calculate hmac-sha256", e);
		}
	}
	
//	static public byte[] calcHmacSha0256(PrivateKey secretKey, byte[] message) {
//		try {
//			byte[] hmacSha256 = null;
//			Mac mac = Mac.getInstance("RSA");
//			mac.init(secretKey);
//			hmacSha256 = mac.doFinal(message);
//			return hmacSha256;
//		} catch (Exception e) {
//			throw new RuntimeException("Failed to calculate hmac-sha256", e);
//		}
//	}
	
	static public String bytesToHex(byte[] hashInBytes) {
        StringBuilder sb = new StringBuilder();
        for (byte b : hashInBytes) {
            sb.append(String.format("%02x", b));
        }
        return sb.toString();
    }
	
	static public byte[] hexStringToByteArray(String s) {
	    int len = s.length();
	    byte[] data = new byte[len / 2];
	    for (int i = 0; i < len; i += 2) {
	        data[i / 2] = (byte) ((Character.digit(s.charAt(i), 16) << 4)
	                             + Character.digit(s.charAt(i+1), 16));
	    }
	    return data;
	}
}