package tesiProject;

import java.io.ByteArrayOutputStream;
//import java.io.FileInputStream;
import java.lang.management.ManagementFactory;
import java.lang.management.OperatingSystemMXBean;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.math.BigInteger;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketTimeoutException;
import java.nio.charset.StandardCharsets;
//import java.security.KeyStore;
import java.security.MessageDigest;
//import java.security.PrivateKey;
import java.sql.Timestamp;
import java.util.Arrays;
import javax.crypto.KeyGenerator;
import javax.crypto.spec.SecretKeySpec;

public class Puzzle {
	private int nBitPuzzle/*, nByte*/; //the puzzle instance's difficulty
	private byte[] h2, hp, h;
	private Timestamp timestamp;
	private static SecretKeySpec puzzleKey;
	private static Method method;
	private static OperatingSystemMXBean operatingSystemMXBean;

	public Puzzle() {
		hp = new byte[32];
		h2 = new byte[32];
	}
	
	public static void generatePuzzleKey() {
		try {
			KeyGenerator keygen = KeyGenerator.getInstance("AES");
			keygen.init(128);
			byte[] key = keygen.generateKey().getEncoded();
			puzzleKey = new SecretKeySpec(key, "AES");
		}catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void setCPUMethod() {
		operatingSystemMXBean = ManagementFactory.getOperatingSystemMXBean();
		for (Method m : operatingSystemMXBean.getClass().getDeclaredMethods()) {
			if (m.getName().equals("getSystemCpuLoad") && Modifier.isPublic(m.getModifiers())) {
				m.setAccessible(true);
				method = m;
				break;
			}
		}
	}

// ----------------------------------------- SERVER SIDE------------------------------------------------------
	
	public void generatePuzzle(byte[] data, int nBitPuzzle) {
		try {
			String message;
			MessageDigest messageDigest = MessageDigest.getInstance("SHA-256");
			timestamp  = new Timestamp(System.currentTimeMillis());
			BigInteger h2Big;

//			nBitPuzzle = generateNBitPuzzle();
//			nBitPuzzle = 8;
			this.nBitPuzzle = nBitPuzzle;
//			System.out.println("Generato da nBit: "+nBitPuzzle);
			if(nBitPuzzle > 0) {
				message = new String(data, StandardCharsets.UTF_8);
				//System.out.println(new StringBuffer(message).append(timestamp));
				h = Functions.calcHmacSha256(puzzleKey, new StringBuffer(message).append(timestamp)
						.toString().getBytes("UTF-8"));
				if(h[0]==-1 || h[0]==0) {
					h[0]=0x37;
//					System.out.println("QUI CAZZOOOOOOOOOOO");
				}
				hp = messageDigest.digest(h); //h'
				h2Big = new BigInteger(h.clone());
				for(int i = 0; i < nBitPuzzle; i++)
					h2Big = h2Big.clearBit(i);
				h2 = h2Big.toByteArray();
				
//				if(h[0]==-1 || h[0]==0) {
//					for(int i = 31; i > 0; i--)
//						h2[i] = h22[i-1];
//					h2[0] = h[0];
//				}else
//					h2 = h22;
				
//				message = new String(data, StandardCharsets.UTF_8);
//				//System.out.println(new StringBuffer(message).append(timestamp));
//				h = Functions.calcHmacSha256(puzzleKey, new StringBuffer(message).append(timestamp)
//						.toString().getBytes("UTF-8"));
//				hp = messageDigest.digest(h); //h'				
//				System.out.println("QUI H: "+Functions.bytesToHex(h));
//			if(h[0]==-1 || h[0]==0)
//					System.out.println("QUI CAZZOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO");
//				h2Big = new BigInteger(h.clone());
//				for(int i = 0; i < nBitPuzzle; i++)
//					h2Big = h2Big.clearBit(i);
//				byte[] h22 = h2Big.toByteArray();
//				for(int i = 0; i < h22.length; i++)
//					h2[i] = h22[i];
				
			}
		}catch(Exception e) {
			e.printStackTrace();
		}
	}

	public void sendPuzzle(DatagramSocket ds, InetAddress clientAddress, int remotePort) {
		try {
			ByteArrayOutputStream sendPuzzleStream = new ByteArrayOutputStream();
			byte[] sendPuzzle;

			sendPuzzleStream.write((int)nBitPuzzle);
			if(nBitPuzzle != -1) {
				sendPuzzleStream.write(hp);
				sendPuzzleStream.write(h2);
			}
			sendPuzzle = sendPuzzleStream.toByteArray();
//			System.out.println("Inviati NBIT: "+nBitPuzzle);
//			System.out.println("Inviati hh: "+Functions.bytesToHex(h));
//			System.out.println("Inviati h2: "+Functions.bytesToHex(h2));
//			System.out.println("Inviati hp: "+Functions.bytesToHex(hp));
			DatagramPacket dp = new DatagramPacket(sendPuzzle,sendPuzzle.length,
					clientAddress, remotePort);
			ds.send(dp);
		}catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	private int generateNBitPuzzle() {
		try {
			double usage = (double)method.invoke(operatingSystemMXBean);
//			System.out.println("Current usage: "+usage);
			if(usage < Functions.CPU_THRESHOLD)
				return -1;
			else
				return (int)Math.round((usage)*20);
		}catch(Exception e) {
			e.printStackTrace();
		}
		return -1;
	}

	public boolean checkPuzzle(byte[] v) {
		//return Arrays.equals(v,0,32,h,0,32);
		for(int i = 0; i < 32 ; i++)
			if(h[i] != v[i])
				return false;
		return true;
	}
	
// ----------------------------------------- CLIENT SIDE------------------------------------------------------
	
	public void receivePuzzle(DatagramSocket ds) throws SocketTimeoutException {
		try {
			byte[] received = new byte[1024], receivedPuzzle;
			DatagramPacket dpPuzzle = new DatagramPacket(received, received.length);

			ds.receive(dpPuzzle);
			receivedPuzzle = dpPuzzle.getData();
			nBitPuzzle = receivedPuzzle[0];
			if(nBitPuzzle == -1) {
				//System.out.println("nBit vale nell'if: "+nBitPuzzle);
			}else {
				nBitPuzzle = nBitPuzzle & 0xFF;
				//nByte = (256-nBitPuzzle+(8-(256-nBitPuzzle)%8))/8;
				hp = Arrays.copyOfRange(receivedPuzzle, 1, 33); //32 consecutive bytes
				h2 = Arrays.copyOfRange(receivedPuzzle, 33, /*33+32*/65); //last 32 bytes
//				System.out.println("Ricevuto NBIT: "+nBitPuzzle);
//				System.out.println("Ricevuto h2: "+Functions.bytesToHex(h2));
//				System.out.println("Ricevuto hp: "+Functions.bytesToHex(hp));
			}
		}catch(SocketTimeoutException se) {
			se.printStackTrace();
			throw se;
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}

	public byte[] resolvePuzzle() {
		try {
			BigInteger h2Big = new BigInteger(h2);
			BigInteger bigI, hBig;
			MessageDigest messageDigest = MessageDigest.getInstance("SHA-256");
			byte[] hpTry;

//			System.out.println("Resolving puzzle of "+nBitPuzzle+" nBit difficulty");
//			System.out.println("h2BigInteger: "+Functions.bytesToHex(h2Big.toByteArray()));
			for(int i = 0; i < Math.pow(2,nBitPuzzle)+1; i++) {
				bigI = BigInteger.valueOf((long)i);
				hBig = h2Big.add(bigI);
//				hBig = h2Big.add(BigInteger.ONE);
				//System.out.println(i+" = "+" h: "+bytesToHex(hBig.toByteArray()));
				hpTry = messageDigest.digest(hBig.toByteArray());
				if(Arrays.equals(hpTry, hp)) {
//					System.out.println("Puzzle solution found!");
					h = hBig.toByteArray();
					return h;
				}
			}
		}catch(Exception e) {
			e.printStackTrace();
		}
		System.out.println("Null: "+Functions.bytesToHex(h2));
		return null;
	}
	
	public byte[] getH() {
		return h;
	}

	public byte[] getH2() {
		return h2;
	}

	public byte[] getHp() {
		return hp;
	}
	
	public int getNBitPuzzle() {
		return nBitPuzzle;
	}
	
	public Timestamp getTimestamp() {
		return timestamp;
	}
}
